//	LN^LCDɐV\f
//	wt]xH쎺	http://jsdiy.webcrow.jp

/*
y|[gΉz	ATtiny85		x:݂Ȃ(PB5RESET) -:
bit		7	6	5	4	3	2	1	0
portB	x	x	*	-	-	SCL	-	SDA		USI-TWI
									
							SCK	MISO MOSI
yATtiny85z
|-210|
|VBBB|
>    |
|BBBG|
|534-|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Lo:01100010(62), Hi:11011111(DF)
Low: 01100010 (62)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:CLKOɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11011111 (DF)
     |||||+++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3, 011:2.3, 010:2.2, 001:1.9, 000:2)
     ||||+-- EESAVE (ChipEEPROM 0:ێ, 1:)
     |||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) HVŜ
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PORT))

Ext: -------1 (FF)
	        +-- SELFPRGEN f[^V[gQ
*/
/*
yrhz
Atmel Studio 7 (Version: 7.0.1931 - )
ATtiny85  1MHzi8MHz/8j

yXVz
2019/03	v0.10
	ō쐬B
	Program Memory Usage 	:	778 bytes   9.5 % Full
	Data Memory Usage 		:	71 bytes   13.9 % Full

2019/04/01	v1.00
	uߘavtHgB
	Program Memory Usage 	:	778 bytes   9.5 % Full
	Data Memory Usage 		:	71 bytes   13.9 % Full
*/

#include <avr/io.h>
#include <util/delay.h>
#include "usiTwiMaster.h"
#include "twiclcd/I2cCharLcdLib.h"

//OID
enum
{
	CHAR_ID_Nen	= 0x00,
	CHAR_ID_Gatsu,
	CHAR_ID_Nichi,
	CHAR_ID_Hei,
	CHAR_ID_Sei,
	CHAR_ID_NewEraKanjiA,
	CHAR_ID_NewEraKanjiB,
	//
	CHAR_ID_LENGTH
}
ECharId;

//O`
static	const	uint8_t	defCharList[][8] =
{
	//N
	{
		0b10000,
		0b11111,
		0b00100,
		0b11111,
		0b10100,
		0b11111,
		0b00100,
		0b00000
	},
	
	//
	{
		0b01111,
		0b01001,
		0b01111,
		0b01001,
		0b01111,
		0b01001,
		0b10001,
		0b00000
	},
	
	//
	{
		0b11111,
		0b10001,
		0b10001,
		0b11111,
		0b10001,
		0b10001,
		0b11111,
		0b00000
	},
	
	//
	{
		0b11111,
		0b00100,
		0b10101,
		0b00100,
		0b11111,
		0b00100,
		0b00100,
		0b00000
	},
	
	//
	{
		0b00101,
		0b11111,
		0b10100,
		0b10101,
		0b11010,
		0b11010,
		0b10101,
		0b00000
	},
	
	//
	{
		0b00100,
		0b01010,
		0b10001,
		0b01111,
		0b00101,
		0b00101,
		0b00100,
		0b00000
	},
	
	//a
	{
		0b00100,
		0b11000,
		0b01000,
		0b11111,
		0b11011,
		0b11011,
		0b01000,
		0b00000
	}
};

//V̓ǂݕ
static	const	char*	YomiShinGengou	= "(ڲ)";

/*
	ߘaiCj
	
	
	
	
	
	
	
	
*/

int	main(void)
{
	for (uint8_t i = 0; i < 10; i++){ _delay_ms(100); }
	
	//I2C
	TWI_MasterInit();
	
	//LCD
	I2CLCD_Init(I2CLCD_DEFAULT_SLA, 16, 2);
	I2CLCD_SetLineMode(LCD_LINEMODE_COMBINE | LCD_LINEMODE_OVERWRITE, LCD_CURSOR_ON);
	
	//Oo^
	for (uint8_t i = 0; i < CHAR_ID_LENGTH; i++)
	{
		I2CLCD_DefChar(i, defCharList[i]);
		_delay_ms(50);
	}

	//\
	//	@@i~J^j
	//	2019N51X^[gI
	I2CLCD_SetPos(0, 0);
	I2CLCD_PutChar(CHAR_ID_Hei);
	I2CLCD_PutChar(CHAR_ID_Sei);
	I2CLCD_PutChar(' ');
	I2CLCD_PutChar(0x7E);	//''
	I2CLCD_PutChar(' ');
	I2CLCD_PutChar(CHAR_ID_NewEraKanjiA);
	I2CLCD_PutChar(CHAR_ID_NewEraKanjiB);
	I2CLCD_PutString(YomiShinGengou);
	
	I2CLCD_SetPos(1, 0);
	I2CLCD_PutUInt(2019);
	I2CLCD_PutChar(CHAR_ID_Nen);
	I2CLCD_PutUInt(5);
	I2CLCD_PutChar(CHAR_ID_Gatsu);
	I2CLCD_PutUInt(1);
	I2CLCD_PutChar(CHAR_ID_Nichi);
	I2CLCD_PutString("!");

	return 0;
}
